import java.awt.*;
import java.awt.geom.Point2D;

public class Bullet extends Projectile
{
	private int damage;
	
	public Bullet (Point2D.Double p, int direction, int damage)
	{
		super(new Point2D.Double(p.x, p.y), 2, 2, direction);
		
		this.damage = damage;
	}
	
	public boolean move (double dist)
	{
		return move(dist, 0);
	}
	
	public void cycle ()
	{
		if (! move(24))
		{
			GameArea.getLevel().removeEntity(this);
		}
	}
	
	public boolean collision (Entity e)
	{
		if (e instanceof Damageable)
		{
			Damageable entity = (Damageable) e;
			
			entity.damage(damage);
			
			GameArea.getLevel().removeEntity(this);
			
			return true;
		}
		else
		{
			return super.collision(e);
		}
	}
	
	public void draw (Graphics g, int x, int y)
	{
		int relativeX = leftEdge() - x;
		int relativeY = topEdge() - y;
		
		g.setColor(Color.BLACK);
		g.fillOval(relativeX, relativeY, 3, 3);
	}
}
