import java.awt.geom.Point2D;

class Guard extends ArmedHuman
{
	private int i = 1;
	private int j = 20;
	
	Guard (Point2D.Double p)
	{
		super(p, 11, 16, 25);
		
		setWeapons(new Weapon[] {
			new Unarmed(this, new Sprite(Store.getFrames("guard"))),
			new Pistol(this, new Sprite(Store.getFrames("guard-pistol"))),
		});
		
		setWeapon(1);
		
		Sprite sprite = new Sprite(Store.getFrames("guard-death"));
		
		setDeathSprite(sprite);
	}
	
	public void cycle ()
	{
		Player player = Player.getInstance();
		
		if (player.getWeapon() instanceof Unarmed)
		{
			turnLeft();
		}
		else
		{
			int diff = direction - directionTo(player);
			
			while (diff < -24)
			{
				diff += 48;
			}
			
			while (diff >= 24)
			{
				diff -= 48;
			}
			
			if (-3 < diff && diff < 3)
			{
				if (i % j == 0)
				{
					weapon.fire();
					
					j = (int) (Math.random() * 50) + 50;
				}
					
				//diff = (Math.random() > 0.5) ? -1 : 1;
				
				i++;
			}
			
			if (diff < 0)
			{
				turnRight();
			}
			else if (diff > 0)
			{
				turnLeft();
			}
		}
	}
}
